//
// RolesAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class RolesAPI {
    /**
     Create new role

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func createRole(body: RoleCreate, completion: @escaping ((_ data: RoleGet?,_ error: Error?) -> Void)) {
        createRoleWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Create new role
     - POST /api/v1/roles
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "is_internal" : true,
  "name" : "name",
  "description" : "description",
  "id" : 0
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<RoleGet> 
     */
    open class func createRoleWithRequestBuilder(body: RoleCreate) -> RequestBuilder<RoleGet> {
        let path = "/api/v1/roles"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<RoleGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Delete role with provided ID

     - parameter roleId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func deleteRole(roleId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        deleteRoleWithRequestBuilder(roleId: roleId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Delete role with provided ID
     - DELETE /api/v1/roles/{role_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter roleId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func deleteRoleWithRequestBuilder(roleId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/roles/{role_id}"
        let roleIdPreEscape = "\(roleId)"
        let roleIdPostEscape = roleIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{role_id}", with: roleIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get role with provided ID

     - parameter roleId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getRole(roleId: Int, completion: @escaping ((_ data: RoleGet?,_ error: Error?) -> Void)) {
        getRoleWithRequestBuilder(roleId: roleId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get role with provided ID
     - GET /api/v1/roles/{role_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "is_internal" : true,
  "name" : "name",
  "description" : "description",
  "id" : 0
}}]
     - parameter roleId: (path)  

     - returns: RequestBuilder<RoleGet> 
     */
    open class func getRoleWithRequestBuilder(roleId: Int) -> RequestBuilder<RoleGet> {
        var path = "/api/v1/roles/{role_id}"
        let roleIdPreEscape = "\(roleId)"
        let roleIdPostEscape = roleIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{role_id}", with: roleIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<RoleGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get list of role members

     - parameter roleId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getRoleMembers(roleId: Int, completion: @escaping ((_ data: RoleMemberList?,_ error: Error?) -> Void)) {
        getRoleMembersWithRequestBuilder(roleId: roleId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of role members
     - GET /api/v1/roles/{role_id}/members
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "members" : [ {
    "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "is_active" : true,
    "is_superuser" : true,
    "avatar_url" : "http://example.com/aeiou",
    "role_id" : 5,
    "organization_id" : 6,
    "last_name" : "last_name",
    "groups" : [ {
      "name" : "name",
      "id" : 1
    }, {
      "name" : "name",
      "id" : 1
    } ],
    "id" : 0,
    "organization_name" : "organization_name",
    "first_name" : "first_name",
    "email" : ""
  }, {
    "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "is_active" : true,
    "is_superuser" : true,
    "avatar_url" : "http://example.com/aeiou",
    "role_id" : 5,
    "organization_id" : 6,
    "last_name" : "last_name",
    "groups" : [ {
      "name" : "name",
      "id" : 1
    }, {
      "name" : "name",
      "id" : 1
    } ],
    "id" : 0,
    "organization_name" : "organization_name",
    "first_name" : "first_name",
    "email" : ""
  } ]
}}]
     - parameter roleId: (path)  

     - returns: RequestBuilder<RoleMemberList> 
     */
    open class func getRoleMembersWithRequestBuilder(roleId: Int) -> RequestBuilder<RoleMemberList> {
        var path = "/api/v1/roles/{role_id}/members"
        let roleIdPreEscape = "\(roleId)"
        let roleIdPostEscape = roleIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{role_id}", with: roleIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<RoleMemberList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get list of role permissions

     - parameter roleId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getRolePermissions(roleId: Int, completion: @escaping ((_ data: PermissionList?,_ error: Error?) -> Void)) {
        getRolePermissionsWithRequestBuilder(roleId: roleId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of role permissions
     - GET /api/v1/roles/{role_id}/permissions
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "permissions" : [ "auditlog_read", "auditlog_read" ]
}}]
     - parameter roleId: (path)  

     - returns: RequestBuilder<PermissionList> 
     */
    open class func getRolePermissionsWithRequestBuilder(roleId: Int) -> RequestBuilder<PermissionList> {
        var path = "/api/v1/roles/{role_id}/permissions"
        let roleIdPreEscape = "\(roleId)"
        let roleIdPostEscape = roleIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{role_id}", with: roleIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PermissionList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get list of roles

     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getRoles(completion: @escaping ((_ data: RoleList?,_ error: Error?) -> Void)) {
        getRolesWithRequestBuilder().execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of roles
     - GET /api/v1/roles
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "roles" : [ {
    "is_internal" : true,
    "name" : "name",
    "description" : "description",
    "id" : 0
  }, {
    "is_internal" : true,
    "name" : "name",
    "description" : "description",
    "id" : 0
  } ]
}}]

     - returns: RequestBuilder<RoleList> 
     */
    open class func getRolesWithRequestBuilder() -> RequestBuilder<RoleList> {
        let path = "/api/v1/roles"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<RoleList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Update role with provided ID

     - parameter body: (body)  
     - parameter roleId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateRole(body: RoleUpdate, roleId: Int, completion: @escaping ((_ data: RoleGet?,_ error: Error?) -> Void)) {
        updateRoleWithRequestBuilder(body: body, roleId: roleId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update role with provided ID
     - PUT /api/v1/roles/{role_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "is_internal" : true,
  "name" : "name",
  "description" : "description",
  "id" : 0
}}]
     - parameter body: (body)  
     - parameter roleId: (path)  

     - returns: RequestBuilder<RoleGet> 
     */
    open class func updateRoleWithRequestBuilder(body: RoleUpdate, roleId: Int) -> RequestBuilder<RoleGet> {
        var path = "/api/v1/roles/{role_id}"
        let roleIdPreEscape = "\(roleId)"
        let roleIdPostEscape = roleIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{role_id}", with: roleIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<RoleGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
